#!/usr/bin/perl -w

## Conjugador para o galego RAG-ILG
## Autor: Pablo Gamallo, 15 de Janeiro de 2006

use locale;
use POSIX;

setlocale(LC_CTYPE,"pt_PT");


$file =  "verbosGZ" ;
open (FILE, "<$file") or die "O ficheiro não pode ser aberto: $!\n";


$verbo = shift(@ARGV);

if ($verbo eq "") {
$verbo=<STDIN>;
}

chomp $verbo;


#$verbo=shift(@ARGV);

my $cons = "bBdDtTpPkKvVfFcCçÇzZkKlLrRnNmMpPjJxXsShHqQgGñÑ ";


my $FN = "FN";
my $IP = "IP";

my $PI = "PI";
my $EI = "EI";
my $TI = "TI";
my $II = "II";
my $FI = "FI";
my $MI = "MI";

my $PS = "PS";
my $FS = "FS";
my $IS = "IS";

my $IA = "IA";
my $IN = "IN";


$nomeV{$FN} = "FORMAS NOMINAIS ";
$nomeV{$IP} = "INFINITIVO PESSOAL ";

$nomeV{$PI} = "PRESENTE DO INDICATIVO ";
$nomeV{$EI} = "PRETÉRITO DO INDICATIVO ";
$nomeV{$FI} = "FUTURO DO INDICATIVO ";
$nomeV{$TI} = "FUTURO DO PRETÉRITO DO INDICATIVO ";
$nomeV{$II} = "IMPERFEITO DO INDICATIVO ";
$nomeV{$MI} = "MAIS-QUE-PERFEITO DO CONJUNTIVO ";

$nomeV{$PS} = "PRESENTE DO CONJUNTIVO ";
$nomeV{$FS} = "FUTURO DO CONJUNTIVO " ;
$nomeV{$IS} = "IMPERFEITO DO CONJUNTIVO ";

$nomeV{$IA} = "IMPERATIVO AFIRMATIVO ";
$nomeV{$IN} = "IMPERATIVO NEGATIVO ";



$verboESP="";
if ($verbo =~ /(er|ar|ir|ír)$/) {
    ($verboR, $verboD) = ($verbo =~ /([a-zçñáéíóúüëïöü]*)(er|ar|ir|ír)$/);
     print STDERR "#$verboR# - #$verboD#\n";
}

else {
    $verboESP = $verbo;
    print STDERR "#$verboESP#\n";
}



while ($line = <FILE>) {
    chomp $line;
    
    if ($line =~ /^paradigma/) {
        $line = TirarSeparadores($line);
	($tmp, $paradigma) = split ('\:', $line) ;
#        print STDERR "#$paradigma#\n"; 
    }

    if ($line =~ /^raiz/) {
       $line =  TirarSeparadores($line);
        (@tmp) = split ('\:', $line) ;
        if ($#tmp == 1) {
	    $raiz1 = $tmp[1];
            $Raiz1{$paradigma} = $raiz1;
            #print STDERR "$raiz1 -- $paradigma\n";
         
	}
        elsif ($#tmp == 2) {
	    $raiz1 = $tmp[1];
            $raiz2 = $tmp[2];
            $Raiz1{$paradigma} = $raiz1;
            $Raiz2{$paradigma} = $raiz2 ;
       }
       elsif ($#tmp == 3) {
	   $raiz1 = $tmp[1];
	   $raiz2 = $tmp[2];
           $raiz3 = $tmp[3];
	   $Raiz1{$paradigma} = $raiz1;
	   $Raiz2{$paradigma} = $raiz2 ;
           $Raiz3{$paradigma} = $raiz3 ;
       }

       elsif ($#tmp == 4) {
	   $raiz1 = $tmp[1];
	   $raiz2 = $tmp[2];
           $raiz3 = $tmp[3];
           $raiz4 = $tmp[4];
	   $Raiz1{$paradigma} = $raiz1;
	   $Raiz2{$paradigma} = $raiz2 ;
           $Raiz3{$paradigma} = $raiz3 ;
           $Raiz4{$paradigma} = $raiz4 ;
       }
    }

    if ($line =~ /^sufixo/) {
	$line =  TirarSeparadores($line);
        (@tmp) = split ('\:', $line) ;
        $sufixo = $tmp[1];
        $Sufixo{$paradigma} = $sufixo;
    }

   
   if ($line =~ /^FN/) {
       $Conj{$paradigma}{$FN} = $line;
   }
   if ($line =~ /^PI/) {
       $Conj{$paradigma}{$PI} = $line;
   }
   if ($line =~ /^II/) {
       $Conj{$paradigma}{$II} = $line;
   }
   if ($line =~ /^IA/) {
       $Conj{$paradigma}{$IA} = $line;
   }
   if ($line =~ /^IP/) {
       $Conj{$paradigma}{$IP} = $line;
   }
   if ($line =~ /^EI/) {
       $Conj{$paradigma}{$EI} = $line;
   }
   if ($line =~ /^MI/) {
       $Conj{$paradigma}{$MI} = $line;
   }
   if ($line =~ /^TI/) {
       $Conj{$paradigma}{$TI} = $line;
   }
   if ($line =~ /^FI/) {
       $Conj{$paradigma}{$FI} = $line;
   }
   if ($line =~ /^PS/) {
       $Conj{$paradigma}{$PS} = $line;
   }
   if ($line =~ /^IS/) {
       $Conj{$paradigma}{$IS} = $line;
   }   
   if ($line =~ /^FS/) {
       $Conj{$paradigma}{$FS} = $line;
   }
   if ($line =~ /^IN/) {
       $Conj{$paradigma}{$IN} = $line;
   }

   if ($line =~ /^</) {
	    $line = TirarSeparadores($line);
            (@tmp) = split ('\,', $line);
            for ($i=0; $i<=$#tmp; $i++) {
		$Verbo{$paradigma}{$tmp[$i]}++;
            }
	}
}


$found=0;
foreach $p (keys %Verbo) {
       foreach $v (keys %{ $Verbo{$p} }) {
                 # print STDERR "#$p# -- #$v# : #$Raiz1{$p}# -- #$Raiz2{$p}#\n"; 
	   if ($v eq $verbo) {
	      
              if ( (defined $Raiz1{$p}) &&  
                   ($Raiz1{$p} eq "-") ) {
                    ImprimirIrreg($p);
                    $found=1;
	      }
              

              elsif (defined $Sufixo{$p}) {
                   
		   $sufixo = $Sufixo{$p};
                   ($prefixo) = ($p =~ /([a-zçñáéíóúüëïöü]*)$sufixo/);
                   ($prefixoNovo) = ($verbo =~ /([a-zçñáéíóúüëïöü]*)$sufixo/);
                   
                   print STDERR "Sufixo: $Sufixo{$p} -- Prefixo: $prefixo -- PrefixoNovo: $prefixoNovo\n";
                   #$novaRaiz = $prefixo . $sufixo;
                   foreach $tempo (keys %{$Conj{$p}}) {
                         $Conj{$p}{$tempo} =~ s/\:$prefixo/\:$prefixoNovo/g ;
		   }
                   ImprimirIrreg($p);
                   $found=1;   
	      }
              elsif ($p eq "doer") {
                  print STDERR "Raizes escolhidas: #$Raiz1{$p}# -- #$Raiz2{$p}# -- #$Raiz3{$p}# -- #$Raiz4{$p}#\n";
		  $verboR2 = $verboR;
                  $verboR3 = $verboR;
                  $verboR4 = $verboR;
                  $verboR2 =~ s/$/í/;
                  $verboR3 =~ s/$/i/;
		  $verboR4 =~ s/$/ï/;
		  foreach $tempo (keys %{$Conj{$p}}) {
                         $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
                         $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
                         $Conj{$p}{$tempo} =~ s/\:$Raiz3{$p}/\:$verboR3/g ;
                         $Conj{$p}{$tempo} =~ s/\:$Raiz4{$p}/\:$verboR4/g ;
		  }
		  ImprimirIrreg($p);
                  $found=1;   
	      }   
              elsif ($p eq "muscar") {
                   print STDERR "Raizes escolhida: #$Raiz1{$p}# -- #$Raiz2{$p}# -- #$Raiz3{$p}\n";
		  $verboR2 = $verboR;
                  $verboR3 = $verboR;
                  $verboR2 =~ s/u([$cons]?)([$cons]?)$/o$1$2/;
                  $verboR3 =~ s/c$/qu/;
                  foreach $tempo (keys %{$Conj{$p}}) {
                          $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
                          $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
                          $Conj{$p}{$tempo} =~ s/\:$Raiz3{$p}/\:$verboR3/g ;
		  }
		  ImprimirIrreg($p);
                  $found=1;   
	      }
               elsif ($p eq "lucir") {
                   print STDERR "Raizes escolhida: #$Raiz1{$p}# -- #$Raiz2{$p}# -- #$Raiz3{$p}\n";
		  $verboR2 = $verboR;
                  $verboR3 = $verboR;
                  $verboR2 =~ s/u([$cons]?)([$cons]?)$/o$1$2/;
                  $verboR3 =~ s/c$/z/;
                  foreach $tempo (keys %{$Conj{$p}}) {
                          $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
                          $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
                          $Conj{$p}{$tempo} =~ s/\:$Raiz3{$p}/\:$verboR3/g ;
		  }
		  ImprimirIrreg($p);
                  $found=1;   
	      }

	      elsif ( ($p eq "afiar") || ($p eq "prohibir") ) {
                   print STDERR "Raizes escolhidas: #$Raiz1{$p}# -- #$Raiz2{$p}#\n";
                  $verboR2 = $verboR;
		  $verboR2 =~ s/i([$cons]?)$/í$1/;
                  foreach $tempo (keys %{$Conj{$p}}) {
                      $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
                      $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
                  }
	          #print "$v = $Conj{$p}{$PI}\n"; 
                  ImprimirIrreg($p);  
                  $found=1;
       	      }
	      elsif ( ($p eq "saudar") || ($p eq "construír") || ($p eq "reunir") ) {
                   print STDERR "Raizes escolhida: #$Raiz1{$p}# -- #$Raiz2{$p}#\n";
		  $verboR2 = $verboR;
                  $verboR2 =~ s/u([$cons]?)$/ú$1/;
                  foreach $tempo (keys %{$Conj{$p}}) {
                          $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
                          $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
		  }
		  ImprimirIrreg($p);
                  $found=1;   
	      }
              
              elsif ( ($p eq "ferir") || ($p eq "progredir")) {
                   print STDERR "Raizes escolhida: #$Raiz1{$p}# -- #$Raiz2{$p}#\n";
		  $verboR2 = $verboR;
                  $verboR2 =~ s/e([$cons]?)([$cons]?)$/i$1$2/;
                  foreach $tempo (keys %{$Conj{$p}}) {
                          $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
                          $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
		  }
		  ImprimirIrreg($p);
                  $found=1;   
	      }
              elsif ($p eq "saír") {
                   print STDERR "Raizes escolhida: #$Raiz1{$p}# -- #$Raiz2{$p}#\n";
		  $verboR2 = $verboR;
                  $verboR2 =~ s/$/i/;
                  foreach $tempo (keys %{$Conj{$p}}) {
                          $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
                          $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
		  }
		  ImprimirIrreg($p);
                  $found=1;   
	      }
              elsif ($p eq "seguir") {
                   print STDERR "Raizes escolhida: #$Raiz1{$p}# -- #$Raiz2{$p}#\n";
		  $verboR2 = $verboR;
                  $verboR2 =~ s/egu$/ig/;
                  foreach $tempo (keys %{$Conj{$p}}) {
                          $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
                          $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
		  }
		  ImprimirIrreg($p);
                  $found=1;   
	      }
               elsif ($p eq "subir") {
                   print STDERR "Raizes escolhida: #$Raiz1{$p}# -- #$Raiz2{$p}#\n";
		  $verboR2 = $verboR;
                  $verboR2 =~ s/u([$cons]?)([$cons]?)$/o$1$2/;
                  foreach $tempo (keys %{$Conj{$p}}) {
                          $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
                          $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
		  }
		  ImprimirIrreg($p);
                  $found=1;   
	      }

              #casos regulares:
              elsif (!defined $Raiz2{$p}) {
                    print STDERR "Raiz escolhida: #$Raiz1{$p}#\n";
		  print STDERR "Verbo regular listado\n";
                  foreach $tempo (keys %{$Conj{$p}}) {
		      $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
		  }
                  ImprimirReg($p);
                  $found=1;
	     }
              elsif ($verbo =~ /zar$/)  {
                    print STDERR "Raizes escolhidas: #$Raiz1{$p}# -- #$Raiz2{$p}#\n";
		    print STDERR "Verbo regular  com duas raizes e listado\n";
		    $verboR2 = $verboR;
		    $verboR2 =~ s/z$/c/;
                    foreach $tempo (keys %{$Conj{$p}}) {
		           $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
		           $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
		    }
		    ImprimirReg($p);
		    $found=1;
	     }            
	     elsif ( (defined $Raiz2{$p}) && ($verbo =~ /c[ei]r$/) ) {
                    print STDERR "Raizes escolhidas: #$Raiz1{$p}# -- #$Raiz2{$p}# \n";
		    print STDERR "Verbo regular  com duas raizes e listado\n";
		    $verboR2 = $verboR;
		    $verboR2 =~ s/c$/z/;
                    foreach $tempo (keys %{$Conj{$p}}) {
		           $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
		           $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
		    }
		    ImprimirReg($p);
		    $found=1;
	     }
             elsif ( (defined $Raiz2{$p}) && ($verbo =~ /güir$/) ) {
                    print STDERR "Raizes escolhidas: #$Raiz1{$p}# -- #$Raiz2{$p}# \n";
		    print STDERR "Verbo regular  com duas raizes e listado\n";
		    $verboR2 = $verboR;
		    $verboR2 =~ s/gü$/gu/;
                    foreach $tempo (keys %{$Conj{$p}}) {
		           $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
		           $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
		    }
		    ImprimirReg($p);
		    $found=1;
	     }
             elsif ($verbo =~ /[cgq](u?)[aei]r$/)  {
                    print STDERR "Raizes escolhidas: #$Raiz1{$p}# -- #$Raiz2{$p}#\n";
		    print STDERR "Verbo regular  com duas raizes e listado\n";
		    $verboR2 = $verboR;
                    if ($verbo =~ /car$/) {
		        $verboR2 =~ s/c$/qu/;
		    }
                    elsif ($verbo =~ /gar$/) {
		        $verboR2 =~ s/g$/gu/; 
		    }
                    if ($verbo =~ /gu[ei]r$/) {
		        $verboR2 =~ s/gu$/g/;
		    }
                    elsif ($verbo =~ /qu[ei]r$/) {
		        $verboR2 =~ s/qu$/c/;
		    }
                    foreach $tempo (keys %{$Conj{$p}}) {
		           $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
		           $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
		    }
		    ImprimirReg($p);
		    $found=1;
	     }       
            
            
          }
       }
}
 


  
if  ( (!$found) && (defined $verboR) ) {

    if ($verbo =~ /cer$/) {
        $p = "coñecer";
        print STDERR "Raizes escolhidas: #$Raiz1{$p}# -- #$Raiz2{$p}#\n";
	$verboR2 = $verboR;
	$verboR2 =~ s/c$/z/;
        foreach $tempo (keys %{$Conj{$p}}) {
	   $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
	   $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
        }
	ImprimirReg($p);
	$found=1;
    }
    elsif ($verbo =~ /cir$/) {
        $p = "traducir";
        print STDERR "Raizes escolhidas: #$Raiz1{$p}# -- #$Raiz2{$p}#\n";
	$verboR2 = $verboR;
	$verboR2 =~ s/c$/z/;
        foreach $tempo (keys %{$Conj{$p}}) {
	   $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
	   $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
        }
	ImprimirReg($p);
	$found=1;
   }
   elsif ($verbo =~ /guer$/) {
        $p = "erguer";
        print STDERR "Raizes escolhidas: #$Raiz1{$p}# -- #$Raiz2{$p}#\n";
	$verboR2 = $verboR;
	$verboR2 =~ s/gu$/g/;
        foreach $tempo (keys %{$Conj{$p}}) {
	   $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
	   $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
        }
	ImprimirReg($p);
	$found=1;
   }
   elsif ($verbo =~ /quer$/) {
        $p = "erquer";
        print STDERR "Raizes escolhidas: #$Raiz1{$p}# -- #$Raiz2{$p}#\n";
	$verboR2 = $verboR;
	$verboR2 =~ s/qu$/c/;
        foreach $tempo (keys %{$Conj{$p}}) {
	   $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
	   $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
        }
	ImprimirReg($p);
	$found=1;
   }
   elsif ($verbo =~ /guir$/) {
        $p = "extinguir";
        print STDERR "Raizes escolhidas: #$Raiz1{$p}# -- #$Raiz2{$p}#\n";
	$verboR2 = $verboR;
	$verboR2 =~ s/gu$/g/;
        foreach $tempo (keys %{$Conj{$p}}) {
	   $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
	   $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
        }
	ImprimirReg($p);
	$found=1;
   }
    elsif ($verbo =~ /güír$/) {
        $p = "argüír";
        print STDERR "Raizes escolhidas: #$Raiz1{$p}# -- #$Raiz2{$p}#\n";
	$verboR2 = $verboR;
	$verboR2 =~ s/gü$/gu/;
        foreach $tempo (keys %{$Conj{$p}}) {
	   $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
	   $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
        }
	ImprimirReg($p);
	$found=1;
   }
    elsif ($verbo =~ /quir$/) {
        $p = "delinquir";
        print STDERR "Raizes escolhidas: #$Raiz1{$p}# -- #$Raiz2{$p}#\n";
	$verboR2 = $verboR;
	$verboR2 =~ s/qu$/q/;
        foreach $tempo (keys %{$Conj{$p}}) {
	   $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
	   $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
        }
	ImprimirReg($p);
	$found=1;
   }
    elsif ($verbo =~ /uír$/) {
        $p = "construír";
        print STDERR "Raizes escolhidas: #$Raiz1{$p}# -- #$Raiz2{$p}#\n";
	$verboR2 = $verboR;
	$verboR2 =~ s/u$/ú/;
        foreach $tempo (keys %{$Conj{$p}}) {
	   $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
	   $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
        }
	ImprimirReg($p);
	$found=1;
   }
   elsif ($verbo =~ /car$/) {
        $p = "comunicar";
        print STDERR "Raizes escolhidas: #$Raiz1{$p}# -- #$Raiz2{$p}#\n";
	$verboR2 = $verboR;
	$verboR2 =~ s/c$/qu/;
        foreach $tempo (keys %{$Conj{$p}}) {
	   $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
	   $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
        }
	ImprimirReg($p);
	$found=1;
   }
    elsif ($verbo =~ /gar$/) {
        $p = "chegar";
        print STDERR "Raizes escolhidas: #$Raiz1{$p}# -- #$Raiz2{$p}#\n";
	$verboR2 = $verboR;
	$verboR2 =~ s/c$/qu/;
        foreach $tempo (keys %{$Conj{$p}}) {
	   $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
	   $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
        }
	ImprimirReg($p);
	$found=1;
   }
   elsif ($verbo =~ /zar$/) {
        $p = "abrazar";
        print STDERR "Raizes escolhida: #$Raiz1{$p}# -- #$Raiz2{$p}#\n";
	$verboR2 = $verboR;
	$verboR2 =~ s/z$/c/;
        foreach $tempo (keys %{$Conj{$p}}) {
	   $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
	   $Conj{$p}{$tempo} =~ s/\:$Raiz2{$p}/\:$verboR2/g ;
        }
	ImprimirReg($p);
	$found=1;
   }

   elsif ($verboD eq "ar") {
      $p = "cantar"; 
      print STDERR "Raiz escolhida: #$Raiz1{$p}#\n";
      foreach $tempo (keys %{$Conj{$p}}) {
          $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
      }
      ImprimirReg($p);
   }
   elsif ($verboD eq "er") {
      $p = "vender"; 
      print STDERR "Raiz escolhida: #$Raiz1{$p}#\n";
      foreach $tempo (keys %{$Conj{$p}}) {
          $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
      }
      ImprimirReg($p);
   }
   elsif ($verboD eq "ir") {
      $p = "partir"; 
      print STDERR "Raiz escolhida: #$Raiz1{$p}#\n";
      foreach $tempo (keys %{$Conj{$p}}) {
          $Conj{$p}{$tempo} =~ s/\:$Raiz1{$p}/\:$verboR/g ;
      }
      ImprimirReg($p);
   }

}

if  (!$verboR) {
       print "Não foi reconhecido como verbo. Tente de novo\n\n"
    }



sub TirarSeparadores {
    local ($x) = @_;

    $x =~ s/\<//g;
    $x =~ s/\>//g;
    $x =~ s/ //g;
   return $x
}

sub ImprimirReg {
    local ($x) = @_ ;

    print STDERR "## paradigma regular, deduzido de: <$x>\n\n";
 
    foreach $tmp (keys %{$Conj{$p}}) {
        #$Conj{$x}{$tmp} =~ s/^[A-Z]+\:/\n$nomeV{$tmp}\n/ ;
        #$Conj{$x}{$tmp} =~ s/\:/  /g ;
    }
   
    print "$Conj{$x}{$FN}\n"; 
    print "$Conj{$x}{$IP}\n";

    print "$Conj{$x}{$PI}\n";
    print "$Conj{$x}{$II}\n";    
    print "$Conj{$x}{$EI}\n";
    print "$Conj{$x}{$MI}\n";
    print "$Conj{$x}{$TI}\n";
    print "$Conj{$x}{$FI}\n";

    print "$Conj{$x}{$PS}\n";
    print "$Conj{$x}{$IS}\n";
    print "$Conj{$x}{$FS}\n";

    print "$Conj{$x}{$IA}\n";
    print "$Conj{$x}{$IN}\n";
    

   return 1
}


sub ImprimirIrreg {
    local ($x) = @_ ;


    print STDERR "## paradigma irregular: <$x>\n\n";

    foreach $tmp (keys %{$Conj{$p}}) {
       # $Conj{$x}{$tmp} =~ s/^[A-Z]+\:/\n$nomeV{$tmp}\n/ ;
       # $Conj{$x}{$tmp} =~ s/\:/  /g ;
    }

    print "$Conj{$x}{$FN}\n"; 
    print "$Conj{$x}{$IP}\n";

    print "$Conj{$x}{$PI}\n";
    print "$Conj{$x}{$II}\n";    
    print "$Conj{$x}{$EI}\n";
    print "$Conj{$x}{$MI}\n";
    print "$Conj{$x}{$TI}\n";
    print "$Conj{$x}{$FI}\n";

    print "$Conj{$x}{$PS}\n";
    print "$Conj{$x}{$IS}\n";
    print "$Conj{$x}{$FS}\n";

    print "$Conj{$x}{$IA}\n";
    print "$Conj{$x}{$IN}\n";


   return 1
   }
